<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>WSI Annotator</title>
{#    <script type="text/javascript" src="{{ url_for('static', filename='jquery.js') }}"></script>#}
{#    for POST and GET#}
    <script type="text/javascript" src="{{ url_for('static', filename='jquery.min.js') }}"></script>
    <script type="text/javascript" src="{{ url_for('static', filename='openseadragon.js') }}"></script>
{#    <script type="text/javascript" src="{{ url_for('static', filename='openseadragon-scalebar.js') }}"></script> #}

	<script>
		$(document).ready(function(){
  			$(".clinical_meta_data").click(function(){
    		$("#patient_info").slideToggle("slow");
  			});
		});
		$(document).ready(function(){
  			$("#bio_meta_data").click(function(){
    		$("#bio_info").slideToggle("slow");
  			});
		});
	</script>￼
	<script>
		$(function(){
			$(".patient_info_submit").click(function(){
				//$('#successAlert').remove();
				obj=document.getElementsByName("patient_info_box");
				check_val=[];
				for (k in obj){
					if(obj[k].checked) check_val.push(obj[k].value);
				};
				var data=JSON.stringify(check_val);
				$.ajax({
					type:'POST',
					url:'/get_patient_meta/',
					async:true,
					data:data,
					contentType:'application/json',
				})
				.done(function(data){
					$('#patient_info_successAlert').empty();
					result=JSON.parse(data);
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#patient_info_successAlert').append(key+":"+value+'<br>');
					})
				});

				event.preventDefault();

			});
		})


	</script>

	<script>
		$(function(){
			$("#bio_info_submit").click(function(){
				//$('#successAlert').remove();
				obj=document.getElementsByName("bio_info_box");
				check_val=[];
				for (k in obj){
					if(obj[k].checked) check_val.push(obj[k].value);
				};
				var data=JSON.stringify(check_val);
				$.ajax({
					type:'POST',
					url:'/get_bio_meta/',
					async:true,
					data:data,
					contentType:'application/json',
				})
				.done(function(data){
					$('#bio_info_successAlert').empty();
					result=JSON.parse(data);
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#bio_info_successAlert').append(key+":"+value+'<br>');
					})
				});

				event.preventDefault();

			});
		})


	</script>


</head>

<body style="width: 98%; height: 700px; float: left">
{% with message = get_flashed_messages(with_categories=ture) %}
  {% if messages %}
      {% for category,message in messages %}
        <div class="alert alert-{{ category }}">
            {{ message }}
        </div>
      {% endfor %}
  {% endif %}
{% endwith %}
{#Refreshing function#}
{#<div class='container'>#}
{#    <h3>Refresh command</h3>#}
{#        <form>#}
{#            <a href=# id=process_input><button class='btn btn-default'>Refresh</button></a>#}
{#        </form>#}
{#    <p id=result></p>#}
{#</div>#}

{#OSD viewer#}

<div style="height: 100%; width: 100%; float: left">
    <h1 style="
        float: left;
        font-family: 'Sukhumvit Set';
        color: rgb(20%, 20%, 20%);
        width: 98%;
        margin: 5px auto 5px auto;
        padding: 5px 0 5px 15px;
        background-color: #bef1b8;
        border-radius: 10px 10px 0 0;
        ">
		Whole-Slide Image Annotator</h1>

    <div id="openseadragon1" style="float: left; margin: 10px auto 10px auto; width: 800px; height: 450px;"></div>
	<div id="meta_data" style="float:right;padding:5px;text-align:center;background-color:#e5eecc;border:solid 1px #c3c3c3;width:500px">patient_info</div>
	<div id="clinical_meta_data" style="padding:5px;text-align:center;background-color:#e5eecc;border:solid 1px #c3c3c3;float:right;width:500px">clinical_meta_data</div>
	<div id="patient_info" style="padding:5px;background-color:#e5eecc;border:solid 1px #c3c3c3;float:right;width:500px;display:none">
		<form name='patient_info_table'>
			<input type="checkbox" class="patient_info_box" name="patient_info_box" value="Gender">Gender<br>
			<input type="checkbox" class="patient_info_box" name="patient_info_box" value="Race">Race<br>
			<input type="checkbox" class="patient_info_box" name="patient_info_box" value="Days_to_birth">Days_to_birth<br>
			<button id="patient_info_submit">submit</button>
			<div id="patient_info_successAlert"> </div>
		</form>
	</div>

	<div id="bio_meta_data" style="padding:5px;text-align:center;background-color:#e5eecc;border:solid 1px #c3c3c3;float:right;width:500px">biospecimen_meta_data</div>
	<div id="bio_info" style="padding:5px;background-color:#e5eecc;border:solid 1px #c3c3c3;float:right;width:500px;display:none">
		<form name='bio_info_table'>
			<input type="checkbox" class="bio_info_box" name="bio_info_box" value="section_location">section_location<br>
			<input type="checkbox" class="bio_info_box" name="bio_info_box" value="sample_type">sample_type<br>
			<input type="checkbox" class="bio_info_box" name="bio_info_box" value="days_to_collection">days_to_collection<br>
			<button id="bio_info_submit">submit</button>
			<div id="bio_info_successAlert"> </div>
		</form>
		</div>


    <div style="float: left;margin: 10px auto 10px auto; width: 98%; font-family: 'Sukhumvit Set'">
        <h2 style="margin: 0 0 0 10px">Pre-segmentation level</h2>
            <div id="PS_lv" style="background-color: aquamarine; border-radius: 20px; padding: 10px;"></div>

        <h2 style="margin: 10px 0 0 10px">Tumor grading</h2>
            <div id="grading" style="background-color: goldenrod; border-radius: 20px; padding: 10px;"></div>

        <a href=# id=undo><button class='btn btn-default'>Undo</button></a>

        <div class="container">
            <h3>Annotator ID: </h3>
            <form>
                <input type=text size=5 name=anno_id>
                <a href=# id=anno_id><button class='btn btn-default'>Change Annotator</button></a>
            </form>
            <p id=annotator_result>Current annotator: unknown</p>
        </div>

        <div class="container">
            <h3>Slide ID: </h3>
            <form>
                <input type=text size=5 name=slide_id>
                <a href=# id=slide_id><button class='btn btn-default'>Change Slide</button></a>
            </form>

            <p id=slide_result>Current slide: unknown</p>
        </div>

        <a href=# id=tog_boun><button class='btn btn-default'>Toggle boundary</button></a>

    </div>
</div>

<script type="text/javascript">
    // Disable right-click
    window.oncontextmenu=function(e){
        e.preventDefault();
    };

    var data_draw = {}; //recording the points -> should be JSON
    var point_number=0; //the length of data_draw

    var MAX_X=5000,MAX_Y=5000; // Default max value
	var UpLeft_X=0,UpLeft_Y=0; //coordinate of UpLeft (top-left coor)
    var X=5000,Y=5000;// width and height that the image asked for(change automatically)
    var DownRight_X=UpLeft_X+X,DownRight_Y=UpLeft_Y+Y;//coordinate of DownRight (bottom-right coor)

	var OCD_X_PX=1000,OCD_Y_PX=1000; //wide and length asking for (viewing image size)
    var ps_lv = 0, MAX_ps_lv = 2; // Max is 6
    var grading=0, Max_grading=3;

    var keyboard=['Z','X','C','V','B','N','M']; //control the ps_lv

    var buffer = 0.05;

    var enableOverlay = false;

	$.getJSON('/_get_info', {}, function(data) {  //get inform and create radio button,
		console.log(data);
		MAX_X=data.img_width-1, MAX_Y=data.img_height-1;
		X=MAX_X; Y=MAX_Y;
		DownRight_X=UpLeft_X+X,DownRight_Y=UpLeft_Y+Y;
        MAX_ps_lv = data.ps_lv;
        {#Max_grading = data.grading#} // For future

        for(var i= 0 ; i<=MAX_ps_lv; i++)
        {
            var radio = document.createElement("input"); //syntax
            radio.type="radio";
            radio.name= "PS_lv";
            radio.id = "" + keyboard[i];
            radio.value=i;
            radio.onchange = function(){
                ps_lv=getRadioValue("PS_lv");}; // function is below
            var text = document.createTextNode(' '+keyboard[i]+' : ' + i +'\u00A0\u00A0\u00A0\u00A0');
            document.getElementById("PS_lv").appendChild(radio);
            document.getElementById("PS_lv").appendChild(text);
            document.getElementById(keyboard[i]).style.marginLeft = "10px";
        }

        for(var i= 0 ; i<=Max_grading; i++)
        {
            var radio = document.createElement("input");
            radio.type="radio";
            radio.name= "grading";
            radio.id = "" + i;
            radio.value=i;
            radio.onchange = function(){
                grading=getRadioValue("grading");};
            if(i==0){
                var text = document.createTextNode(' '+'Healthy'+'\u00A0\u00A0\u00A0\u00A0');
            }
            else {
                var text = document.createTextNode(' '+i+'\u00A0\u00A0\u00A0\u00A0');
            }

            document.getElementById("grading").appendChild(radio);
            document.getElementById("grading").appendChild(text);
            document.getElementById(i.toString()).style.marginLeft = "10px";
        }

        {#document.getElementsByName("PS_lv").style.marginRight = "10px";#}
        document.getElementById("Z").checked=true;
        document.getElementById("0").checked=true;
	});


    var viewer = OpenSeadragon({
        id: "openseadragon1",
        prefixUrl: "{{ url_for('static', filename='images/') }}",
        tileSources: {
            type: 'image',
            url: "{{ slide_url }}",
        },
        minZoomImageRatio: 0,
        maxZoomPixelRatio: 30,

        gestureSettingsMouse: {
            flickEnabled: false,
        },

        springStiffness: 10,
        animationTime: 0.5,

        zoomPerSecond: 0.5,
        zoomPerScroll: 1.3,
        {#blendTime: 1,#}

	});

    // For both ps_lv and grading ratio buttons.
    var getRadioValue = function(name){ //get which item is chosen (name is radio name such as "PS_lv" and "grading")
        var radio_tag = document.getElementsByName(name);
        for(var i=0;i<radio_tag.length;i++){
            if(radio_tag[i].checked){
                return radio_tag[i].value;
            }
        }
    };

    var recording_point = function(event) {
                    var Point_position = viewer.viewport.pointFromPixel(event.position);
                    var data_get = {
                        x : UpLeft_X + Point_position.x * X,
                        y : UpLeft_Y + Point_position.y * X,
                        grading : grading,
                        ps_lv : ps_lv,
                    };
                    data_draw[''+point_number]=data_get;
                    point_number=point_number+1;
                };

    var update_image =function(){
		var data_askFor= {//asking image is larger than we see

			var1:Math.round (UpLeft_X-(DownRight_X-UpLeft_X)*buffer),    // buffer is the extra edge of the image that we load
            var2:Math.round (UpLeft_Y-(DownRight_Y-UpLeft_Y)*buffer),
            var3:Math.round (DownRight_X+(DownRight_X-UpLeft_X)*buffer),
			var4:Math.round (DownRight_Y+(DownRight_Y-UpLeft_Y)*buffer),
            var5:OCD_X_PX, var6:OCD_X_PX,   // 5 is static, var6 is change according to the image ratio.
            var7:ps_lv,
		};

        viewer.close();     // freeze the OSD
        if(data_askFor.var1<0){     data_askFor.var1=0;      }
        if(data_askFor.var2<0){     data_askFor.var2=0;      }
        if(data_askFor.var3>MAX_X){ data_askFor.var3=MAX_X;  }
        if(data_askFor.var4>MAX_Y){ data_askFor.var4=MAX_Y;  }
        data_askFor.var6=data_askFor.var5
                          *(data_askFor.var4-data_askFor.var2)
                          /(data_askFor.var3-data_askFor.var1);
        data_askFor.var6=Math.round (data_askFor.var6);

        console.log(data_askFor);

		$.getJSON('/_update_image', data_askFor, //asking image
			function(data) {
                if(data.exit_code!=0){alert("something wrong during processing image");
                }
				console.log(data);
				viewer.tileSources.url = data.slide_url;
				viewer.addTiledImage({
                    tileSource: viewer.tileSources,
                    minZoomImageRatio: 0,
                    maxZoomPixelRatio: 30,  // can be change to 10
                    success : function()
		            {
                        viewer.viewport.zoomTo((data_askFor.var3-data_askFor.var1)/
                                                                        (DownRight_X-UpLeft_X),{},true);
                        // true = no animation
			            viewer.viewport.panTo({
                        x:((DownRight_X+UpLeft_X)/2-data_askFor.var1)/(data_askFor.var3-data_askFor.var1),
                        y:((DownRight_Y+UpLeft_Y)/2-data_askFor.var2)/(data_askFor.var3-data_askFor.var1),
                        },true);
			            // x and y should be relative center coor of the img.
                        UpLeft_X=data_askFor.var1;
                        UpLeft_Y=data_askFor.var2;
                        DownRight_X=data_askFor.var3;
                        DownRight_Y=data_askFor.var4;
                        X=data_askFor.var3-data_askFor.var1;
                        Y=data_askFor.var4-data_askFor.var2;
		            },
                });
				if (enableOverlay) {
                    viewer.addSimpleImage({
                        url: '/static/s.png',
                        replace: false,
                        opacity: 1,
                        success: function () {
                            viewer.viewport.zoomTo((data_askFor.var3 - data_askFor.var1) /
                                (DownRight_X - UpLeft_X), {}, true);
                            // true = no animation
                            viewer.viewport.panTo({
                                x: ((DownRight_X + UpLeft_X) / 2 - data_askFor.var1) / (data_askFor.var3 - data_askFor.var1),
                                y: ((DownRight_Y + UpLeft_Y) / 2 - data_askFor.var2) / (data_askFor.var3 - data_askFor.var1),
                            }, true);
                            // x and y should be relative center coor of the img.
                            UpLeft_X = data_askFor.var1;
                            UpLeft_Y = data_askFor.var2;
                            DownRight_X = data_askFor.var3;
                            DownRight_Y = data_askFor.var4;
                            X = data_askFor.var3 - data_askFor.var1;
                            Y = data_askFor.var4 - data_askFor.var2;
                        },
                    });
                }
			}
		);
	};

    var update_bounds = function()
    {
        var bounds = viewer.viewport.getBounds();

        UpLeft_X=UpLeft_X+bounds.x*X;
        UpLeft_Y=UpLeft_Y+bounds.y*X;
        DownRight_X =UpLeft_X+bounds.width*X;
        DownRight_Y =UpLeft_Y+bounds.height*X;
    };

    var update_zoom = function() { //do if pin changed
        var zoom = viewer.viewport.getZoom(true);
        var imageZoom = viewer.viewport.viewportToImageZoom(zoom);
        /*
        imageZoom>1 = zoom in more than image resolution
        zoom<1 = viewer larger than image
        (therefore) (zoom<1 && X<MAX_X) = only refresh for the 1st time that viewer is larger than image.
        X is of latest image
        MAX_X is of WSI
         */
		if(imageZoom>1||(zoom<1 && X<MAX_X)){
		    // Refresh image
            update_bounds();
		    update_image();
		}
        else {update_pin();}
    };

    var update_pin = function() {//do if out of bounds
		var bounds = viewer.viewport.getBounds();
		if((bounds.x<0&&UpLeft_X>0)||
           (bounds.y<0&&UpLeft_Y>0)||
           ((bounds.x+bounds.width) >1&&DownRight_X<MAX_X)||
           ((bounds.y+bounds.height)>(Y/X) &&DownRight_Y<MAX_Y))
        {
            {#console.log(bounds);#}
            update_bounds();
            update_image();
		}
    };

    // Run the func after user interact with OSD
    viewer.addHandler('open', function(){

		update_image(); // get first image

        var tracker = new OpenSeadragon.MouseTracker({ //set mouse tracker
                element: viewer.container,
                moveHandler: recording_point,
            });
        tracker.setTracking(false);

		viewer.addHandler('animation-finish', update_zoom);

        viewer.addHandler('canvas-nonprimary-press',  function (e) {
            if(e.button==2){
                recording_point(e);tracker.setTracking(true);}
         });
        viewer.addHandler('canvas-nonprimary-release',  function (e) {
            if(e.button==2){
                tracker.setTracking(false);
                $.post("/_record",data_draw).done(function(data){
                    console.log(data_draw );
                    data_draw={};
                    point_number=0;
                    {#update_bounds();#}
		            {#update_image();#}

                    }).fail(function(){ alert("ask for help") ;
                });
                }
        });
    });

    document.onkeydown=function(e){  //listen to the keboard;
        var key=String.fromCharCode(window.event ? e.keyCode :e.which);
        console.log(key);
        if(document.getElementById(""+key))
        {
            document.getElementById(""+key).checked=true;
            document.getElementById(""+key).onchange();
            {#update_bounds();#}
            {#update_image();#}
        }
        if(key == 'R' || key == 'Z' || key == 'X' || key == 'C'){
            console.log('Refreshing...');
            update_bounds();
            update_image();
        }

    };

    </script>

<script>
    // Undo function
    $(function() {
        $('a#undo').bind('click', function() {
        $.getJSON(
            '/_undo',
            {cmd: 1,},
            //$('input[name="cmd"]').val()
            function(data) {console.log(data.status)});
        return false;
        });
    });

    // Set annotator id
    $(function() {
        $('a#anno_id').bind('click', function() {
            console.log("sending annotator id");
            $.getJSON(
                '/_annotator_id',
                {id: $('input[name="anno_id"]').val(),},
                function(data) {
                    console.log(data.status);
                    $("#annotator_result").text("Current annotator: " + data.result);
                });
            return false;
        });
    });

    // Set slide id
    $(function() {
        $('a#undo').bind('click', function() {
            console.log("sending slide id");
            $.getJSON(
                '/_slide_id',
                {id: $('input[name="slide_id"]').val(),},
                function(data) {
                    console.log(data.status);
                    $("#slide_result").text("Current slide: " + data.result);
                });
            return false;
        });
    });

    // Toggle sub-region boundary
    $(function() {
        $('a#tog_boun').bind('click', function() {
            console.log("toggle sub-region boundary");
            $.getJSON(
                '/_tog_boun',
                {cmd: 1,},
                function(data) {
                    console.log(data.status);
                    $("#slide_result").text("Boundary (on/off): " + data.result);
                    update_bounds();
                    update_image();
                });
            return false;
        });
    });


    </script>
</body>
</html>